<?php
/**
 *
 * @author TopCMM daniel@topcmm.com
 * @copyright (c) 2010 TopCMM
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

if (!defined('IN_PHPBB'))
{
	exit;
}

include($phpbb_root_path . 'includes/functions_requestRemote.' . $phpEx);
/**
 * @package acp
 */
class acp_fchat
{
	var $u_action;
	/**
	 * Constructor
	 */
	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template;
		global $phpbb_root_path, $phpEx;

		$this->tpl_name 	= 'acp_fchat';
		$this->page_title 	= $user->lang(FC_TITLE);

		switch ($mode)
		{
			case 'config':
				$this->configuration();
				break;
			case 'moreconfig':
				$pwd = microtime(TRUE) * 10000;
				$sql = 'INSERT INTO ' . FCHAT_TABLE . ' VALUES(null, ' . $db->sql_escape($user->data['user_id']) . ',' . $pwd . ')';
				$db->sql_query($sql);
				$init_user = "";
				if(!empty($user->data['username']) && !empty($pwd) ){
					$init_user .= "&init_user=".rawurlencode($user->data['username'])."&init_password=".$pwd;
				}
				$template->assign_vars(array(
                        'S_FC_ADMIN'            => true,
                        'S_FC_SERVER'           => $config['fc_server'],
                        'U_FC_ADMIN'            => $config['fc_client_loc'] . 'admin_123flashchat.swf?init_host='.$config['fc_server_host'].'&init_port='.$config['fc_server_port']. $init_user . (($config['fc_server'] == 1) ? "&init_group=" . $config['fc_group'] : ''),
                        'U_ACTION'				=> $this->u_action,
				));
				break;
		}
		add_form_key('acp_fchat');
	}

	/**
	 * 123 Flash Chat  Config
	 */
	function configuration()
	{
		$requestRemote = new topcmmRequestRemote();
		$error = array();
		if(!$requestRemote->checkConfig())
		{
			$error[] = "FC_CONFIGURATION_ERROR";
		}

		ini_set("default_socket_timeout",3);
		global $cache, $config, $db, $user, $auth, $template;
		global $phpbb_root_path, $phpEx;

		$defaultHost = $_SERVER['SERVER_NAME'];
		$defaultServerPort = "51127";
		$defaultPort = "35555";
		$fc_row = array();
		//default configuration port value is 51127 and 35555
		$fc_row['local_client_loc'] = request_var('s_local_client_location', '');

		if(!empty($fc_row['local_client_loc']))
		{
			$fc_row['local_client_loc'] = $this->addSlash($fc_row['local_client_loc']);
			$c_own_loc = $this->validate_client($fc_row['local_client_loc']);
		}
		else
		{
			$c_own_loc = $this->validate_client('http://'.$defaultHost.':'.$defaultPort.'/');
		}

		$c_loc = $c_own_loc;
		$submit = (isset($_POST['submit'])) ? true : false;
		// when submitted
		if ($submit)
		{
			$fc_row['server'] = request_var('server', 2);
			switch ($fc_row['server'])
			{
				case 0:
					if($fc_row['s_local_client_location']){
						$fc_row['server_host'] = @parse_url($fc_row['s_local_client_location'], PHP_URL_HOST);
						$fc_row['server_port'] = '51127';
						$fc_row['http_port'] = '35555';
						$fc_row['api_url'] = 'http://' . $fc_row['server_host'] . ':' . $fc_row['http_port'] . '/';
					}else{
						$fc_row['server_host'] = request_var('s_host', $_SERVER['SERVER_NAME']);
						$fc_row['server_port'] = request_var('s_port', '51127');
						$fc_row['http_port'] = request_var('s_http_port', '35555');
						$fc_row['api_url'] = 'http://' . $fc_row['server_host'] . ':' . $fc_row['http_port'] . '/';
					}
					if ($c_loc)
					{
						if(!empty($fc_row['s_local_client_location']))
						{
							$c_own_loc = $this -> validate_client($fc_row['s_local_client_location']);
						}

						$da = $this -> validate_data_api($fc_row['api_url'] . 'online.js');

						if ($da || $c_own_loc)
						{
							$error[] = 'FC_HTTP_ERROR';
						}
					}
					$fc_row['client_skin'] = request_var('c_skin', '');
					break;
				case 1:
					$fc_row['client_loc'] = request_var('s_local_client_location', '') . (substr(request_var('s_local_client_location', ''),-1,1) != '/' ? '/' : '');

					$urlinfo = parse_url($fc_row['client_loc']);
					$fc_row['server_host'] = $urlinfo['host'];
					if ($content = $requestRemote->requestRemote($fc_row['client_loc']))
					{
						preg_match('/init_port=([0-9]*)/', $content, $matches);
						$fc_row['server_port'] = $matches[1];
					}
					$fc_row['api_url'] = 'http://' . $fc_row['server_host'] . '/';
					$fc_row['group'] = substr($urlinfo['path'],1,-1);

					$c_own_loc = $this -> validate_client($fc_row['client_loc']);
					
					$da = $this->validate_data_api($fc_row['api_url'] . 'online.js?group=' . $fc_row['group']);
					$empty_group = 0;
					if(empty($fc_row['group'])){
						$empty_group = 1;
					}
					if ( $da || $empty_group)
					{
						$error[] = 'FC_CLIENT_LOC_ERROR';
					}
					$fc_row['client_skin'] = request_var('c_skin', '');
					break;
				case 2:
					$room = request_var('room','');
					$fc_row['server_host'] = $defaultHost;
					$fc_row['server_port'] = $defaultServerPort;
					$fc_row['http_port'] = $defaultPort;
					$fc_row['room'] = !empty($room) ? $room : $config['server_name'];
					$fc_row['client_skin'] = request_var('c_skin', '');
					$fc_array['room'] = array('string', false, 1, 50);
					$fc_row['client_loc'] = "http://". $defaultHost . ":" . $defaultPort . "/";
					break;
			}
			$fc_row['room_list'] = request_var('room_list', 0);
			$fc_row['user_list'] = request_var('user_list', 0);
			if (request_var('fullscreen', 0))
			{
				$fc_row['fullscreen'] = 1;
			}
			else
			{
				$fc_row['fullscreen'] = 0;
				$width = request_var('c_width', 0);
				$height = request_var('c_height', 0);
				$fc_row['client_width'] = !empty($width) ? $width : 779;
				$fc_row['client_height'] = !empty($height) ? $height : 528;
				$fc_array['client_width'] = array('num', false, 0, 2000);
				$fc_array['client_height'] = array('num', false, 0, 2000);
			}
			$fc_row['client_lang'] = request_var('c_lang', '');
			//wo jia de			
			$fc_row['sty'] = request_var('sty', '');
			if (!function_exists('validate_data'))
			{
				include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
			}
			if ($fc_array)
			{
				$error = array_merge($error,validate_data($fc_row, $fc_array));
			}
			if (!check_form_key('acp_fchat'))
			{
				$error[] = 'FORM_INVALID';
			}
			if (!sizeof($error))
			{
				foreach ($fc_row as $config_name => $config_value)
				{
					set_config('fc_' . $config_name, $config_value);
				}

				add_log('admin','FC_CONFIG_UPDATE');

				trigger_error($user->lang['FC_CONFIG_SAVED'] . adm_back_link($this->u_action));
			}
			// Replace "error" strings with their real, localised form
			$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);
		}
		// 123 Flash Chat Server Download OS(win/darwin/linux) detected
		$fc_download_url = 'http://www.123flashchat.com/download-now.html?p=123flashchat.' . ((PATH_SEPARATOR==':') ? (stristr(PHP_OS, 'darwin') ?  'dmg' : 'sh') : 'exe');
		$template->assign_vars(array(
			'S_FC_CONFIG'           => true,
            'S_FC_SERVER'           => request_var("server", 0) ? $fc_row['server'] : $config['fc_server'],
			'FC_SERVER_OWN_DOWN'	=> 'Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a>,',
            'FC_SERVER_OWN_SETLOC'	=> 'and set Chat Client Location to: http://&lt;your chat server domain or ip&gt;:35555/',
			'FC_SERVER_HOST_BUY'	=> '<a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, please set the Chat Client Location like this: http://yourhostname.chat.123flashchat.com/ or http://hostservername.123flashchat.com/yourhostname/, <a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a>',
			'FC_SERVER_HOST_TRAI'	=> '<a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname',
			'FC_SERVER_HOST_TRAI_AP'=> 'Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a>',
			'FC_SERVER_FREE_LOBBY'	=> 'This chat server mode is for testing the basic functions, only 1 room supported, no video chat function, and you donot have the administrator of this chat room, ',
			'FC_SERVER_FREE_BOBBYT'	=> 'you may select the mode 1 or 2 to get the full function and full control of your chat room.',
			'FC_SERVER_HOST'        => isset($_POST['s_host']) ? $fc_row['server_host'] : $config['fc_server_host'],
            'FC_SERVER_PORT'        => isset($_POST['s_port']) ? $fc_row['server_port'] : $config['fc_server_port'],
            'FC_HTTP_PORT'          => isset($_POST['s_http_port']) ? $fc_row['http_port'] : $config['fc_http_port'],
            'FC_LOCAL_CLIENT_LOCATION'    => isset($_POST['s_local_client_location']) ? $fc_row['fc_local_client_loc'] : $config['fc_local_client_loc'],
            'FC_DOWNLOAD_URL'       => $fc_download_url,
            'S_FC_CLIENT_OWN_LOCATION'    => $c_loc,
            'FC_CLIENT_LOCATION'    => isset($_POST['s_local_client_location']) ? $fc_row['client_loc'] : $config['fc_client_loc'],
            'FC_ROOM'               => isset($_POST['room']) ? $fc_row['room'] : $config['fc_room'],
            'U_FC_LOGIN_CHAT'       => 'http://' . $config['server_name'] . (($config['script_path'] == '/') ? '' : $config['script_path']) . '/login_chat.php?username=%username%&password=%password%',
            'S_FC_ROOM_LIST'        => isset($_POST['room_list']) ? $fc_row['room_list'] : $config['fc_room_list'],
            'S_FC_USER_LIST'        => isset($_POST['user_list']) ? $fc_row['user_list'] : $config['fc_user_list'],
			'S_FC_FULL'    	        => $config['fc_fullscreen'] ? $config['fc_fullscreen'] : 0,
			'FC_CLIENT_HEIGHT'    	=> isset($_POST['c_height']) ? (($fc_row['client_height'] != '100%') ? $fc_row['client_height'] : '528') : (($config['fc_client_height'] != '100%') ? $config['fc_client_height'] : '528'),
			'FC_CLIENT_WIDTH'    	=> isset($_POST['c_width']) ? (($fc_row['client_width'] != '100%') ? $fc_row['client_width'] : '779') : (($config['fc_client_width'] != '100%') ? $config['fc_client_width'] : '779'),
			'FC_CLIENT_SKIN'     	=> $fc_row['client_skin'] ? $fc_row['client_skin'] : $config['fc_client_skin'],
			'FC_CLIENT_LANG'     	=> isset($_POST['c_lang']) ? $fc_row['client_lang'] : $config['fc_client_lang'],
			'FC_ERROR'				=> isset($error) ? ((sizeof($error)) ? implode('<br />', $error) : '') : '',
			'U_ACTION'				=> $this->u_action
		));
	}


	/**
	 * Check 123 FlashChat Data api
	 * @parm $data_api   Chat Data Api
	 * @return integer config status
	 */
	function validate_data_api($data_api)
	{
		$requestRemote = new topcmmRequestRemote;
		$da = 1;

		if($requestRemote->requestRemote($data_api))
		{
			$da = 0;
		}
		return $da;
	}

	/**
	 * Check 123 FlashChat Client Location
	 * @parm $client_loc   Chat Client Location
	 * @return integer config status
	 */
	function validate_client($client_loc)
	{
		$requestRemote = new topcmmRequestRemote();
		$c_own_loc = 1;
		$swf = $client_loc . '123flashchat.swf';

		if($headers = $requestRemote->requestRemote($swf, 0));
		{
			$c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
		}

		return $c_own_loc;
	}


	function addSlash($path)
	{
		if(substr($path,-1,1) != "/" && !empty($path))
		{
			$path = $path."/";
		}
		return $path;
	}
}
?>